/* AMX Mod script.
*
* Sniper Realism 1.2
* &copy; 2003, SuicideDog
* This file is provided as is (no warranties).
*
*  BASED ON CODE FROM *BMJ* -- thanks man
*
* Ok.. works for scout, awp, g3sg1, sig550, sig552, and aug
*
* Features:
* Fadein like DOD (thanks to BMJ)
* Scope jiggles if scoped, and you move
* Unscopes you if you jump/fall (also prevents scoping in the air)
*/

/* CVARS:
* amx_snipe_realism (1)|0
* turns it off and on
* amx_scopetime1 "1"
* 1 being the time it takes to fade in at level 1 scope
* amx_scopetime2 "4"
* 4 being the time it takes to fade in at level 2 scope
*/

/* TO DO:
*  Add recoil of some kind
*/

#include <amxmodx>
#include <engine>

#define FL_DUCKING (1<<14) // Player flag -- Player is fully crouched
#define FL_ONGROUND (1<<9) // At rest / on the ground

new const PLUGIN[]     = "Sniper Realism"
new const VERSION[]    = "1.2"
new const AUTHOR[]     = "SuicideDog"

new velocityI[3]
new gmsgShake
new taskid[32]

/* PCvars */
new pv_amx_snipe_realism
new pv_amx_scopetime1
new pv_amx_scopetime2

public plugin_init()
       {
       register_plugin ( PLUGIN, VERSION, AUTHOR )
       register_event ( "SetFOV", "scope_func", "be", "1<90" )
       register_event ( "SetFOV", "unscope_func", "be", "1=90" )
       register_event ( "ResetHUD","newround","b" )
       
       pv_amx_snipe_realism  = register_cvar ( "amx_snipe_realism", "1" )
       pv_amx_scopetime1     = register_cvar ( "amx_scopetime1", "1" )
       pv_amx_scopetime2     = register_cvar ( "amx_scopetime2", "4" )
       
       gmsgShake = get_user_msgid ( "ScreenShake" )
}

public newround(id) // this is needed to make sure the lastinv works for unscoping
       {
       switch ( is_user_bot ( id ) )
       {
             case 1:
             return PLUGIN_CONTINUE
       }
       client_cmd(id,"weapon_knife;lastinv")
       return PLUGIN_CONTINUE
}

public scope_func(id)
       {
       
       switch ( get_pcvar_num ( pv_amx_snipe_realism ) )
       {
             case 0:
             return PLUGIN_CONTINUE
       }
       
       switch ( is_user_bot ( id ) )
       {
             case 1:
             return PLUGIN_CONTINUE
       }
       
       static fov
       static bool:DoStuff
       static weapon, clip, ammo
       
       fov   = read_data(1)
       DoStuff       = false
       weapon        = get_user_weapon(id, clip, ammo)
       
       switch ( get_pcvar_num ( pv_amx_snipe_realism ) )
       {
             case 1:
             {
                  switch ( weapon )
                  {
                      case 3,13,18,24:   // scout, awp, g3sg1, sig550
                      DoStuff=true
                  }
             }
             
             case 2:
             {
                  switch ( weapon )
                  {
                      case 3,13,18,24,8,27:      // scout, awp, g3sg1, sig550, sig552, and aug
                      DoStuff=true
                  }
             }
       }
       
       switch ( DoStuff )
       {
             case true:
             {
                  message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, id)
                  if (fov > 20)
                      {
                      write_short(get_pcvar_num(pv_amx_scopetime1)<<12)
                      } else {
                      write_short(get_pcvar_num(pv_amx_scopetime2)<<12)
                  }
                  write_short(1<<16)
                  write_short(1<<1)
                  write_byte(0)
                  write_byte(0)
                  write_byte(0)
                  write_byte(255)
                  message_end()
                  switch ( taskid[id] )
                  {
                      case 0:
                      {
                         static playerid[1]
                         playerid[0] = id
                         taskid[id] = get_user_userid(id)
                         set_task(0.1, "check_movement", taskid[id], playerid[0], 1, "b")
                      }
                  }
             }
       }
       return PLUGIN_CONTINUE
}

public unscope_func(id)
       {
       switch ( is_user_bot ( id ) )
       {
             case 1:
             return PLUGIN_CONTINUE
       }
       message_begin(MSG_ONE, get_user_msgid("ScreenFade"), {0,0,0}, id)
       write_short(1<<1)
       write_short(1<<1)
       write_short(1<<1)
       write_byte(0)
       write_byte(0)
       write_byte(0)
       write_byte(0)
       message_end()
       remove_task(taskid[id])
       taskid[id] = 0
       return PLUGIN_CONTINUE
}

public check_movement(playerid[]) //check for movement
       { 
       
       static id 
       
       id = playerid[0]
       
       switch ( is_user_bot ( id ) )
       {
             case 1:
             return PLUGIN_CONTINUE
       }
       
       static Float:vector[3]
       entity_get_vector(id, EV_VEC_velocity, vector)
       FVecIVec(vector, velocityI)
       
       static flags
       flags = entity_get_int(id, EV_INT_flags)
       
       if (!(flags & FL_ONGROUND)) //if in the air, unscope
             {
             client_cmd(id,"lastinv;lastinv")
             unscope_func(id)
             return PLUGIN_CONTINUE
       }
       
       if (velocityI[0] != 0 || velocityI[1] != 0 || velocityI[2] != 0) //check movement, if moving shake
             {
             if(flags & FL_DUCKING) //if ducking shake less
                  {
                  message_begin(MSG_ONE,gmsgShake,{0,0,0},id)
                  write_short(1<<11) // shake amount
                  write_short(1<<11) // shake lasts this long
                  write_short(1<<11) // shake noise frequency
                  message_end()
             } 
             else
                  {
                  message_begin(MSG_ONE,gmsgShake,{0,0,0},id)
                  write_short(1<<13) // shake amount
                  write_short(1<<11) // shake lasts this long
                  write_short(1<<13) // shake noise frequency
                  message_end()
             }
             return PLUGIN_CONTINUE
       }
       return PLUGIN_CONTINUE
}